/********************************************************************
*================== НПО "Сибирский арсенал" ========================*
*********************************************************************
* 	
* Aplication:   		All
*                       
* Имя файла:			YLabel.cpp
*  
* Версия программы:		1.0
* Framework:			Qt 4.3.2
* Компилятор:			GCC (mingw-gcc rev4.3.2)
* Дата начала:			17.01.2008	
* Последнее обновление:	17.01.2008
* Автор:				Литкевич Юрий Иванович
* Support E-mail:		lit-uriy@yandex.ru
* Лицензия:				GNU GPLv2
*
* Описание:				Мой класс виджета-метки, позваляющий создавать
*						фоновый рисунок 
* 							
* 							
* 							
* Log:
* Date			Athor				Description
* 
*
********************************************************************/



#include "well.h"
// ----------------------------------------------------------------------
const QSize icon24(24,24);// размер иконки в 24 пикселя
const QSize btn24(26,26);// размер кнопки под иконку 24 пикселя
const QSize wellsz(105, 140);// размер виджета
// ----------------------------------------------------------------------

Well::Well( QWidget *parent, int num): QWidget(parent)
{

  QFrame	*frame = new QFrame(parent);
	frame->setMinimumSize(wellsz);
	
  // Layout'ы
  QVBoxLayout	*p_mainlayout = new QVBoxLayout;
  QHBoxLayout	*p_btnlayout = new QHBoxLayout;
  QHBoxLayout	*p_grouplayout = new QHBoxLayout;
  QVBoxLayout	*p_infolayout = new QVBoxLayout;
  
	// Настраиваем Layout'ы
	p_mainlayout->setContentsMargins(2,2,2,2);	// поля лэйаута
	p_mainlayout->setSpacing(3);	// расстояние между виджетами

	p_btnlayout->setContentsMargins(0,0,0,0);	// поля лэйаута
	p_btnlayout->setSpacing(3);		// расстояние между виджетами

	p_grouplayout->setContentsMargins(0,0,0,0);	// поля лэйаута
	p_grouplayout->setSpacing(3);		// расстояние между виджетами

	p_infolayout->setContentsMargins(0,0,0,0);	// поля лэйаута
	p_infolayout->setSpacing(0);		// расстояние между виджетами
	
	
	p_mainlayout->addLayout(p_btnlayout);
	p_mainlayout->addLayout(p_grouplayout);
	


  // Кнопки
  QPushButton	*btnStart = new QPushButton;
  QPushButton	*btnInfo = new QPushButton;
  QPushButton	*btnStop = new QPushButton;
	// Настраиваем кнопки
	btnStart->setMaximumSize(btn24);
	btnStart->setMinimumSize(btn24);
	
	btnInfo->setMaximumSize(btn24);
	btnInfo->setMinimumSize(btn24);
	
	btnStop->setMaximumSize(btn24);
	btnStop->setMinimumSize(btn24);
	
	// Устанавливаем иконки на кнопки
	btnStart->setIcon(QIcon(QString::fromUtf8("pics/24px_On.png")));	
	btnStart->setIconSize(icon24);
	btnStart->setFlat(true);
	
	btnInfo->setIcon(QIcon(QString::fromUtf8("pics/24px_Info.png")));	
	btnInfo->setIconSize(icon24);
	btnInfo->setFlat(true);
	
	btnStop->setIcon(QIcon(QString::fromUtf8("pics/24px_Off.png")));	
	btnStop->setIconSize(icon24);
	btnStop->setFlat(true);
	
	// Помещаем в Layout кнопки
	p_btnlayout->addWidget(btnStop);
	p_btnlayout->addStretch(1);
	p_btnlayout->addWidget(btnInfo);
	p_btnlayout->addStretch(1);	
	p_btnlayout->addWidget(btnStart);

  // Метки 
  QLabel		*p_txt1 = new QLabel(QObject::tr("Давл."));
  QLabel		*p_txt2 = new QLabel(QObject::tr("атм.")); 
  YLabel		*p_well = new YLabel;
  YLabel		*p_prsr = new YLabel;
  YLabel		*p_num = new YLabel;
  QPixmap		*p_pix = new QPixmap;
  QFont 		font;
	

	font.setPointSize(10);
	font.setBold(true);
	font.setWeight(75);
	font.setKerning(true);
	
	p_prsr->setText("13,5");
	p_prsr->setFont(font);
	p_num->setNum(num);
	p_num->setFont(font);
	
	p_txt1->setAlignment(Qt::AlignCenter);
	p_txt2->setAlignment(Qt::AlignCenter);
	
/*	p_well->setFrameShape(QFrame::Box);
	p_num->setFrameShape(QFrame::Box);
	p_prsr->setFrameShape(QFrame::Box);
	p_txt1->setFrameShape(QFrame::Box);
	p_txt2->setFrameShape(QFrame::Box);
*/
	
	// Устанавливаем фон для меток
	p_pix->load("pics/well.png");	
	p_well->setBackground(*p_pix);
	p_pix->load("pics/well_prsr.png");
	p_prsr->setBackground(*p_pix);
	p_pix->load("pics/well_num.png");
	p_num->setBackground(*p_pix);

	// Помещаем в Layout метки
	p_grouplayout->addWidget(p_well);	// рисунок скважины
	p_grouplayout->setAlignment(p_well,Qt::AlignBottom);
	
	p_infolayout->addWidget(p_txt1);	// текст: Давл.
    p_infolayout->addWidget(p_prsr);	// 		  величина давл.
	p_infolayout->addWidget(p_txt2);	// текст: атм.	
	p_infolayout->addStretch(1);		// пробел
	p_infolayout->addWidget(p_num);		//        номер
	
	p_infolayout->setAlignment(p_num,Qt::AlignCenter);
	p_infolayout->setAlignment(p_prsr,Qt::AlignCenter);

	
	p_grouplayout->addLayout(p_infolayout);// Помещаем лэйаут в групповой	

// ======= Эксперимент с раскраской ===================
  QPalette pal;
	pal=parent->palette();	// возьмем палитру родителя
	pal.setColor(frame->backgroundRole(), QColor(QRgb(0xFF3465A4)));	// и подправим ее (#AARRGGBB)
	frame->setPalette(pal);
	frame->setFrameShape(QFrame::StyledPanel);
	frame->setFrameShadow(QFrame::Raised);
	frame->setAutoFillBackground(true);

	// Для родительского виджета установим Layout
	frame->setLayout(p_mainlayout);	
	
	// Установим политику размеров в виксированую, нужно для Layout'ов
	setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
}


 

// Рекомендация размера, для Layout'ов
QSize Well::sizeHint() const
{
    return wellsz;
}



